program Seriovy_prenos;

uses Crt;

const _com1 = $3F8; {standartni pocatecni adresy ctyr prvnich portu}
      _com2 = $2F8;
      _com3 = $3E8;
      _com4 = $2E8;

      suda   = 27; { 3 + 8 + 16      }
      licha  = 11; { 3 + 8           }
      vysoka = 59; { 3 + 8 + 16 + 32 }
      nizka  = 43; { 3 + 8      + 32 }
      zadna  =  3;
      parita = suda;

var com:word;
    znak : byte;

procedure outport(cislo:byte); {posli cislo (byte) na port}
begin
 port[com]:=cislo;
end;

procedure outport_ch(znak:char); {posli znak (char) na port}
begin
 port[com]:=byte(znak);
end;

function inport:byte; {precti port (jako cislo)}
begin
 inport:=port[com];
end;

function inport_ch:char; {precti port (jako znak)}
begin
 inport_ch:=char(port[com]);
end;

function RCif:boolean; {indikator prichazejiciho bytu - vrati true, pokud je na vstupu novy znak}
begin
 RCif := ((port[com+5] and 1) = 1); {indikace nulteho bitu}
end;

procedure OpenPort; {pripravi port k pouziti}
begin
 port[com+1] := $00;
 port[com+3] := $80;
 port[com+0] := $0C; {vybrane rychlosti : 0C=9600, 06=19200, 03=38400, 02=57600, 01=115200}
 port[com+1] := $00;
 port[com+3] := parita;
 port[com+2] := $C7;
 port[com+4] := $0B; { bity 0 a 1 aktivuji vyvody DTR a RTS, ktere mohou slouzit i jako napajeni}
end;

procedure ClosePort; {uzavre port, aby jej mohli pouzivat jine aplikace}
begin
 port[com+4] := $00;
end;

begin
 ClrScr;
 com := _com2; {vyber COM2}
 OpenPort; {otevri vybrany port}
 repeat
  repeat until (RCif) or (KeyPressed); {cekani na prichozi znak, nebo stisk klavesy}
  znak := inport;
  OutPort(znak);
  Writeln('prijato : ',znak:3);
 until KeyPressed;
 ReadKey;
 ClosePort; {uzavri vybrany port}
end.